Index: gnome-settings-daemon-2.28.2/plugins/xrandr/Makefile.am
===================================================================
--- gnome-settings-daemon-2.28.2.orig/plugins/xrandr/Makefile.am
+++ gnome-settings-daemon-2.28.2/plugins/xrandr/Makefile.am
@@ -1,6 +1,5 @@
 icondir = $(datadir)/icons/hicolor
 context = apps
-stock_config_icon_dir = $(datadir)/gnome-settings-daemon/xrandr
 
 BUILT_SOURCES =				\
 	gsd-xrandr-manager-glue.h
@@ -26,35 +25,35 @@ install-data-local:
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/22x22/$(context)
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/24x24/$(context)
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/32x32/$(context)
+	$(mkinstalldirs) $(DESTDIR)$(icondir)/256x256/$(context)
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/scalable/$(context)
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-16.png $(DESTDIR)$(icondir)/16x16/$(context)/gsd-xrandr.png
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-22.png $(DESTDIR)$(icondir)/22x22/$(context)/gsd-xrandr.png
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-24.png $(DESTDIR)$(icondir)/24x24/$(context)/gsd-xrandr.png
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-32.png $(DESTDIR)$(icondir)/32x32/$(context)/gsd-xrandr.png
 	$(INSTALL_DATA) $(srcdir)/gsd-xrandr.svg $(DESTDIR)$(icondir)/scalable/$(context)/gsd-xrandr.svg
-	$(MKDIR_P) $(stock_config_icon_dir)
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-clone-laptop.png $(stock_config_icon_dir)/gsd-xrandr-clone-laptop.png
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-clone-monitors.png $(stock_config_icon_dir)/gsd-xrandr-clone-monitors.png
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-custom.png $(stock_config_icon_dir)/gsd-xrandr-custom.png
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-extended-ontop.png $(stock_config_icon_dir)/gsd-xrandr-extended-ontop.png
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-extended-right.png $(stock_config_icon_dir)/gsd-xrandr-extended-right.png
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-external.png $(stock_config_icon_dir)/gsd-xrandr-external.png
-	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-laptop.png $(stock_config_icon_dir)/gsd-xrandr-laptop.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-clone-laptop.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-clone-laptop.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-clone-monitors.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-clone-monitors.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-custom.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-custom.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-extended-ontop.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-extended-ontop.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-extended-right.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-extended-right.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-external.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-external.png
+	$(INSTALL_DATA) $(srcdir)/gsd-xrandr-laptop.png $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-laptop.png
 
 uninstall-local:
 	rm -f $(DESTDIR)$(icondir)/16x16/$(context)/gsd-xrandr.png
 	rm -f $(DESTDIR)$(icondir)/22x22/$(context)/gsd-xrandr.png
 	rm -f $(DESTDIR)$(icondir)/24x24/$(context)/gsd-xrandr.png
 	rm -f $(DESTDIR)$(icondir)/32x32/$(context)/gsd-xrandr.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr.png
 	rm -f $(DESTDIR)$(icondir)/scalable/$(context)/gsd-xrandr.svg
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-clone-laptop.png
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-clone-monitors.png
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-custom.png
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-extended-ontop.png
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-extended-right.png
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-external.png
-	rm -f $(stock_config_icon_dir)/gsd-xrandr-laptop.png
-	rmdir $(stock_config_icon_dir)
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-clone-laptop.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-clone-monitors.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-custom.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-extended-ontop.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-extended-right.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-external.png
+	rm -f $(DESTDIR)$(icondir)/256x256/$(context)/gsd-xrandr-laptop.png
 
 plugin_LTLIBRARIES = \
 	libxrandr.la