From bdee8f55e1b6d743b25a1a6f0a459212f4cfe619 Mon Sep 17 00:00:00 2001
From: Lee, Chun-Yi <jlee@novell.com>
Date: Tue, 17 Aug 2010 11:24:14 +0800
Subject: [PATCH] Support show up OSD when number lock hotkey pressed

Support show up OSD when number lock hotkey pressed by user.

Signed-off-by: Lee, Chun-Yi <jlee@novell.com>
---
 ...ps_gnome_settings_daemon_keybindings.schemas.in |   11 ++
 plugins/media-keys/Makefile.am                     |    8 ++-
 plugins/media-keys/acme.h                          |    2 +
 plugins/media-keys/gsd-media-keys-manager.c        |   19 ++++
 plugins/media-keys/numlock-disabled.svg            |   99 ++++++++++++++++++++
 plugins/media-keys/numlock-enabled.svg             |   91 ++++++++++++++++++
 6 files changed, 229 insertions(+), 1 deletions(-)
 create mode 100644 plugins/media-keys/numlock-disabled.svg
 create mode 100644 plugins/media-keys/numlock-enabled.svg

Index: gnome-settings-daemon-2.28.2/data/apps_gnome_settings_daemon_keybindings.schemas.in
===================================================================
--- gnome-settings-daemon-2.28.2.orig/data/apps_gnome_settings_daemon_keybindings.schemas.in
+++ gnome-settings-daemon-2.28.2/data/apps_gnome_settings_daemon_keybindings.schemas.in
@@ -259,5 +259,16 @@
             </locale>
         </schema>
 
+        <schema>
+            <key>/schemas/apps/gnome_settings_daemon/keybindings/num_lock</key>
+            <applyto>/apps/gnome_settings_daemon/keybindings/num_lock</applyto>
+            <type>string</type>
+            <default>Num_Lock</default>
+            <locale name="C">
+                <short>Number Lock</short>
+                <long>Binding to do something with Number Lock.</long>
+            </locale>
+        </schema>
+
     </schemalist>
 </gconfschemafile>
Index: gnome-settings-daemon-2.28.2/plugins/media-keys/Makefile.am
===================================================================
--- gnome-settings-daemon-2.28.2.orig/plugins/media-keys/Makefile.am
+++ gnome-settings-daemon-2.28.2/plugins/media-keys/Makefile.am
@@ -29,7 +29,9 @@ ICON_FILES = 			\
 	touchpad-disabled-48.png	\
 	touchpad-enabled-48.png		\
 	touchpad-disabled.svg		\
-	touchpad-enabled.svg
+	touchpad-enabled.svg		\
+	numlock-disabled.svg		\
+	numlock-enabled.svg
 
 install-data-local:
 	$(mkinstalldirs) $(DESTDIR)$(icondir)/16x16/$(context)
@@ -47,6 +49,8 @@ install-data-local:
 	$(INSTALL_DATA) $(srcdir)/touchpad-disabled-24.png $(DESTDIR)$(icondir)/24x24/$(context)/touchpad-disabled.png
 	$(INSTALL_DATA) $(srcdir)/touchpad-disabled-32.png $(DESTDIR)$(icondir)/32x32/$(context)/touchpad-disabled.png
 	$(INSTALL_DATA) $(srcdir)/touchpad-disabled.svg $(DESTDIR)$(icondir)/scalable/$(context)/touchpad-disabled.svg
+	$(INSTALL_DATA) $(srcdir)/numlock-enabled.svg $(DESTDIR)$(icondir)/scalable/$(context)/numlock-enabled.svg
+	$(INSTALL_DATA) $(srcdir)/numlock-disabled.svg $(DESTDIR)$(icondir)/scalable/$(context)/numlock-disabled.svg
 
 uninstall-local:
 	rm -f $(DESTDIR)$(icondir)/16x16/$(context)/touchpad-enabled.png
@@ -59,6 +63,8 @@ uninstall-local:
 	rm -f $(DESTDIR)$(icondir)/24x24/$(context)/touchpad-disabled.png
 	rm -f $(DESTDIR)$(icondir)/32x32/$(context)/touchpad-disabled.png
 	rm -f $(DESTDIR)$(icondir)/scalable/$(context)/touchpad-disabled.svg
+	rm -f $(DESTDIR)$(icondir)/scalable/$(context)/numlock-enabled.svg
+	rm -f $(DESTDIR)$(icondir)/scalable/$(context)/numlock-disabled.svg
 
 gsd-media-keys-manager-glue.h: gsd-media-keys-manager.xml Makefile
 	dbus-binding-tool --prefix=gsd_media_keys_manager --mode=glib-server $< > xgen-$(@F) \
Index: gnome-settings-daemon-2.28.2/plugins/media-keys/acme.h
===================================================================
--- gnome-settings-daemon-2.28.2.orig/plugins/media-keys/acme.h
+++ gnome-settings-daemon-2.28.2/plugins/media-keys/acme.h
@@ -47,6 +47,7 @@ enum {
         STOP_KEY,
         PREVIOUS_KEY,
         NEXT_KEY,
+        NUM_LOCK_KEY,
         HANDLED_KEYS
 };
 
@@ -75,6 +76,7 @@ static struct {
         { STOP_KEY, GCONF_BINDING_DIR "/stop", NULL },
         { PREVIOUS_KEY, GCONF_BINDING_DIR "/previous", NULL },
         { NEXT_KEY, GCONF_BINDING_DIR "/next", NULL },
+        { NUM_LOCK_KEY, GCONF_BINDING_DIR "/num_lock", NULL },
 };
 
 #endif /* __ACME_H__ */
Index: gnome-settings-daemon-2.28.2/plugins/media-keys/gsd-media-keys-manager.c
===================================================================
--- gnome-settings-daemon-2.28.2.orig/plugins/media-keys/gsd-media-keys-manager.c
+++ gnome-settings-daemon-2.28.2/plugins/media-keys/gsd-media-keys-manager.c
@@ -41,6 +41,8 @@
 #include <dbus/dbus-glib.h>
 #include <dbus/dbus-glib-lowlevel.h>
 
+#include <X11/XKBlib.h>
+
 #include "gnome-settings-profile.h"
 #include "gsd-marshal.h"
 #include "gsd-media-keys-manager.h"
@@ -894,6 +896,20 @@ do_multimedia_player_action (GsdMediaKey
         return gsd_media_player_key_pressed (manager, key);
 }
 
+static void
+do_num_lock_action (GsdMediaKeysManager *manager)
+{
+        Display *display = GDK_DISPLAY_XDISPLAY (gdk_display_get_default ());
+        unsigned int state = 0;
+
+        dialog_init (manager);
+        XkbGetIndicatorState(display, XkbUseCoreKbd, &state);
+        gsd_media_keys_window_set_action_custom (GSD_MEDIA_KEYS_WINDOW (manager->priv->dialog),
+                                                 (state & (1 << 1)) ? "numlock-enabled" : "numlock-disabled",
+                                                 FALSE);
+        dialog_show (manager);
+}
+
 static gboolean
 do_action (GsdMediaKeysManager *manager,
            int                  type)
@@ -978,6 +994,9 @@ do_action (GsdMediaKeysManager *manager,
         case NEXT_KEY:
                 return do_multimedia_player_action (manager, "Next");
                 break;
+        case NUM_LOCK_KEY:
+                do_num_lock_action (manager);
+                break;
         default:
                 g_assert_not_reached ();
         }
Index: gnome-settings-daemon-2.28.2/plugins/media-keys/numlock-disabled.svg
===================================================================
--- /dev/null
+++ gnome-settings-daemon-2.28.2/plugins/media-keys/numlock-disabled.svg
@@ -0,0 +1,99 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   version="1.0"
+   width="24.001978"
+   height="24"
+   id="svg7384">
+  <title
+     id="title9167">Moblin Icon Theme</title>
+  <defs
+     id="defs7386" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer3">
+    <rect
+       width="24"
+       height="24"
+       x="-1606"
+       y="234.01474"
+       transform="scale(-1,1)"
+       id="rect24500"
+       style="opacity:0;fill:#ffffff;fill-opacity:1;stroke:none;display:inline" />
+    <path
+       d="M 1600.4022,257.99075 L 1605.992,252.4265 L 1606.002,251.01229 C 1606.002,251.01229 1604.5784,251.01229 1604.5784,251.01229 L 1598.9886,256.57653 C 1598.9886,256.57653 1598.9886,258 1598.9886,258 C 1598.9886,258 1600.4028,257.991 1600.4028,257.991 L 1600.4032,257.99075 L 1600.4032,257.99075 L 1600.4022,257.99075 z"
+       id="path24514"
+       style="fill:#ed2124;fill-opacity:1;stroke:none;display:inline" />
+    <path
+       d="M 1604.5864,257.99075 L 1598.9966,252.4265 L 1598.9866,251.01229 C 1598.9866,251.01229 1600.4101,251.01229 1600.4101,251.01229 L 1606,256.57653 C 1606,256.57653 1606,258 1606,258 C 1606,258 1604.5857,257.991 1604.5857,257.991 L 1604.5854,257.99075 L 1604.5854,257.99075 L 1604.5864,257.99075 z"
+       id="path24516"
+       style="fill:#ed2124;fill-opacity:1;stroke:none;display:inline" />
+    <path
+       d="M 1583.8125,234.0625 C 1582.8365,234.0625 1582.0312,234.86778 1582.0312,235.84375 L 1582.0312,238.21875 C 1582.0312,239.19472 1582.8365,240 1583.8125,240 L 1586.2188,240 C 1587.1947,240 1588,239.19472 1588,238.21875 L 1588,235.84375 C 1588,234.86778 1587.1947,234.0625 1586.2188,234.0625 L 1583.8125,234.0625 z M 1584.0312,236.0625 L 1586,236.0625 L 1586,238 L 1584.0312,238 L 1584.0312,236.0625 z"
+       id="rect24518-1"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1591.8125,234.0625 C 1590.8365,234.0625 1590.0312,234.86778 1590.0312,235.84375 L 1590.0312,238.21875 C 1590.0312,239.19472 1590.8365,240 1591.8125,240 L 1594.2188,240 C 1595.1947,240 1596,239.19472 1596,238.21875 L 1596,235.84375 C 1596,234.86778 1595.1947,234.0625 1594.2188,234.0625 L 1591.8125,234.0625 z M 1592.0312,236.0625 L 1594,236.0625 L 1594,238 L 1592.0312,238 L 1592.0312,236.0625 z"
+       id="rect24522-3"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1599.8125,234.0625 C 1598.8365,234.0625 1598.0312,234.86778 1598.0312,235.84375 L 1598.0312,238.21875 C 1598.0312,239.19472 1598.8365,240 1599.8125,240 L 1602.2188,240 C 1603.1947,240 1604,239.19472 1604,238.21875 L 1604,235.84375 C 1604,234.86778 1603.1947,234.0625 1602.2188,234.0625 L 1599.8125,234.0625 z M 1600.0312,236.0625 L 1602,236.0625 L 1602,238 L 1600.0312,238 L 1600.0312,236.0625 z"
+       id="rect24524-1"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1583.8125,242.0625 C 1582.8365,242.0625 1582.0312,242.86778 1582.0312,243.84375 L 1582.0312,246.21875 C 1582.0312,247.19472 1582.8365,248 1583.8125,248 L 1586.2188,248 C 1587.1947,248 1588,247.19472 1588,246.21875 L 1588,243.84375 C 1588,242.86778 1587.1947,242.0625 1586.2188,242.0625 L 1583.8125,242.0625 z M 1584.0312,244.0625 L 1586,244.0625 L 1586,246 L 1584.0312,246 L 1584.0312,244.0625 z"
+       id="rect24526-9"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1591.8125,242.0625 C 1590.8365,242.0625 1590.0312,242.86778 1590.0312,243.84375 L 1590.0312,246.21875 C 1590.0312,247.19472 1590.8365,248 1591.8125,248 L 1594.2188,248 C 1595.1947,248 1596,247.19472 1596,246.21875 L 1596,243.84375 C 1596,242.86778 1595.1947,242.0625 1594.2188,242.0625 L 1591.8125,242.0625 z M 1592.0312,244.0625 L 1594,244.0625 L 1594,246 L 1592.0312,246 L 1592.0312,244.0625 z"
+       id="rect24528-5"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1583.8125,250 C 1582.8365,250 1582.0312,250.80528 1582.0312,251.78125 L 1582.0312,254.15625 C 1582.0312,255.13222 1582.8365,255.9375 1583.8125,255.9375 L 1586.2188,255.9375 C 1587.1947,255.9375 1588,255.13222 1588,254.15625 L 1588,251.78125 C 1588,250.80528 1587.1947,250 1586.2188,250 L 1583.8125,250 z M 1584.0312,252 L 1586,252 L 1586,253.9375 L 1584.0312,253.9375 L 1584.0312,252 z"
+       id="rect24532-1"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1591.8125,250 C 1590.8365,250 1590.0312,250.80528 1590.0312,251.78125 L 1590.0312,254.15625 C 1590.0312,255.13222 1590.8365,255.9375 1591.8125,255.9375 L 1594.2188,255.9375 C 1595.1947,255.9375 1596,255.13222 1596,254.15625 L 1596,251.78125 C 1596,250.80528 1595.1947,250 1594.2188,250 L 1591.8125,250 z M 1592.0312,252 L 1594,252 L 1594,253.9375 L 1592.0312,253.9375 L 1592.0312,252 z"
+       id="rect24534-8"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1599.8125,243 C 1598.8365,243 1598.0311,243.80526 1598.0312,244.78125 L 1598.0312,247.9375 L 1600.0312,247.9375 L 1600.0312,245 L 1602,245 L 1602,249 L 1604,249 L 1604,244.78125 C 1604,243.80533 1603.1947,243.00001 1602.2188,243 L 1599.8125,243 z"
+       id="rect24536-6"
+       style="opacity:0.5;fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+  </g>
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer5" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer7" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer2" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer8" />
+  <g
+     transform="translate(-1582,-1186.3769)"
+     id="layer1" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer11" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer4" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer12" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer9" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer10" />
+  <g
+     transform="translate(-1582,-234.01474)"
+     id="layer6" />
+</svg>
Index: gnome-settings-daemon-2.28.2/plugins/media-keys/numlock-enabled.svg
===================================================================
--- /dev/null
+++ gnome-settings-daemon-2.28.2/plugins/media-keys/numlock-enabled.svg
@@ -0,0 +1,91 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   version="1.0"
+   width="24"
+   height="24"
+   id="svg7384">
+  <title
+     id="title9167">Moblin Icon Theme</title>
+  <defs
+     id="defs7386" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer3">
+    <rect
+       width="24"
+       height="24"
+       x="-1578"
+       y="234.01474"
+       transform="scale(-1,1)"
+       id="rect24480"
+       style="opacity:0;fill:#ffffff;fill-opacity:1;stroke:none;display:inline" />
+    <path
+       d="M 1555.8125,234.0625 C 1554.8365,234.0625 1554.0312,234.86778 1554.0312,235.84375 L 1554.0312,238.21875 C 1554.0312,239.19472 1554.8365,240 1555.8125,240 L 1558.2188,240 C 1559.1947,240 1560,239.19472 1560,238.21875 L 1560,235.84375 C 1560,234.86778 1559.1947,234.0625 1558.2188,234.0625 L 1555.8125,234.0625 z M 1556.0312,236.0625 L 1558,236.0625 L 1558,238 L 1556.0312,238 L 1556.0312,236.0625 z"
+       id="rect24518"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1563.8125,234.0625 C 1562.8365,234.0625 1562.0312,234.86778 1562.0312,235.84375 L 1562.0312,238.21875 C 1562.0312,239.19472 1562.8365,240 1563.8125,240 L 1566.2188,240 C 1567.1947,240 1568,239.19472 1568,238.21875 L 1568,235.84375 C 1568,234.86778 1567.1947,234.0625 1566.2188,234.0625 L 1563.8125,234.0625 z M 1564.0312,236.0625 L 1566,236.0625 L 1566,238 L 1564.0312,238 L 1564.0312,236.0625 z"
+       id="rect24522"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1571.8125,234.0625 C 1570.8365,234.0625 1570.0312,234.86778 1570.0312,235.84375 L 1570.0312,238.21875 C 1570.0312,239.19472 1570.8365,240 1571.8125,240 L 1574.2188,240 C 1575.1947,240 1576,239.19472 1576,238.21875 L 1576,235.84375 C 1576,234.86778 1575.1947,234.0625 1574.2188,234.0625 L 1571.8125,234.0625 z M 1572.0312,236.0625 L 1574,236.0625 L 1574,238 L 1572.0312,238 L 1572.0312,236.0625 z"
+       id="rect24524"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1555.8125,242.0625 C 1554.8365,242.0625 1554.0312,242.86778 1554.0312,243.84375 L 1554.0312,246.21875 C 1554.0312,247.19472 1554.8365,248 1555.8125,248 L 1558.2188,248 C 1559.1947,248 1560,247.19472 1560,246.21875 L 1560,243.84375 C 1560,242.86778 1559.1947,242.0625 1558.2188,242.0625 L 1555.8125,242.0625 z M 1556.0312,244.0625 L 1558,244.0625 L 1558,246 L 1556.0312,246 L 1556.0312,244.0625 z"
+       id="rect24526"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1563.8125,242.0625 C 1562.8365,242.0625 1562.0312,242.86778 1562.0312,243.84375 L 1562.0312,246.21875 C 1562.0312,247.19472 1562.8365,248 1563.8125,248 L 1566.2188,248 C 1567.1947,248 1568,247.19472 1568,246.21875 L 1568,243.84375 C 1568,242.86778 1567.1947,242.0625 1566.2188,242.0625 L 1563.8125,242.0625 z M 1564.0312,244.0625 L 1566,244.0625 L 1566,246 L 1564.0312,246 L 1564.0312,244.0625 z"
+       id="rect24528"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1555.8125,250 C 1554.8365,250 1554.0312,250.80528 1554.0312,251.78125 L 1554.0312,254.15625 C 1554.0312,255.13222 1554.8365,255.9375 1555.8125,255.9375 L 1558.2188,255.9375 C 1559.1947,255.9375 1560,255.13222 1560,254.15625 L 1560,251.78125 C 1560,250.80528 1559.1947,250 1558.2188,250 L 1555.8125,250 z M 1556.0312,252 L 1558,252 L 1558,253.9375 L 1556.0312,253.9375 L 1556.0312,252 z"
+       id="rect24532"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1563.8125,250 C 1562.8365,250 1562.0312,250.80528 1562.0312,251.78125 L 1562.0312,254.15625 C 1562.0312,255.13222 1562.8365,255.9375 1563.8125,255.9375 L 1566.2188,255.9375 C 1567.1947,255.9375 1568,255.13222 1568,254.15625 L 1568,251.78125 C 1568,250.80528 1567.1947,250 1566.2188,250 L 1563.8125,250 z M 1564.0312,252 L 1566,252 L 1566,253.9375 L 1564.0312,253.9375 L 1564.0312,252 z"
+       id="rect24534"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+    <path
+       d="M 1571.8125,243 C 1570.8365,243 1570.0312,243.80528 1570.0312,244.78125 L 1570.0312,254.15625 C 1570.0312,255.13222 1570.8365,255.9375 1571.8125,255.9375 L 1574.2188,255.9375 C 1575.1947,255.9375 1576,255.13222 1576,254.15625 L 1576,244.78125 C 1576,243.80528 1575.1947,243 1574.2188,243 L 1571.8125,243 z M 1572.0312,245 L 1574,245 L 1574,253.9375 L 1572.0312,253.9375 L 1572.0312,245 z"
+       id="rect24536"
+       style="fill:#bebebe;fill-opacity:1;stroke:none;stroke-width:1.99999976;stroke-linecap:butt;stroke-linejoin:miter;marker:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
+  </g>
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer5" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer7" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer2" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer8" />
+  <g
+     transform="translate(-1554,-1186.3769)"
+     id="layer1" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer11" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer4" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer12" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer9" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer10" />
+  <g
+     transform="translate(-1554,-234.01474)"
+     id="layer6" />
+</svg>